/*
 This source is the barbosa's function unitation versus pairs implementation to be managed by the micr-GA
 */

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "magm.h"


/*
the parameters to call the micro-GA's constructor are
1. (itot) total iterations number.
2. (gmax) 
3. (m) population. (normaly 4).
4. (pc) crossover rate.
5. (pm) mutation rate.
6. (ngenes) how many genes has the genotipe within.
7. (nobjs) how many objectives the problem has.
8. (tampareto) the pareto wanted size.
9. (tammem) the population memory size.
10.(ndivs) 
11 (b) the representation base.
12 (linf) the lower bound
13. (lsup) the upper bound
14. (arch) the micro-GA's archived name
 */

/* 
   the micro-GA algorithm has two virtual methods 
the first one is tue evalua method, in this method goes the function's evaluation.
the second one is the output method, in this method goes what user's output wants.

 */
class Barbosa:public MicroAG{
public:  
  Barbosa(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double *lsup,int *pres,int iguales,int sndelit,double pNRem,char *arch):  MicroAG(itot,gmax,m,pc,pm,ngenes,nobjs,tampareto,tammem,ndivs,b,linf,lsup,pres,iguales,sndelit,pNRem,arch){};
public:
  void evalua(int *cromosoma,double *aptitud);
  void salida(Individuo *ind);
};

/*


 */
void Barbosa::evalua(int *cromosoma,double *aptitud){
  int adyecentes=0,unos=0;
  for(int i=0;i<(bits-1);i++){
    if(cromosoma[i]==1) unos++;
    if((cromosoma[i]-cromosoma[i+1])!=0) adyecentes++;
  }
  if(cromosoma[bits-1]==1) unos++;

  aptitud[0]=adyecentes*-1;
  aptitud[1]=unos*-1;
}
/*this method will archived the  solutions, the almacena method
 */

void Barbosa::salida(Individuo *ind){
  for(int i=0;i<posPARETO;i++){
    almacena(ind[i].aptObj,nObjs);
    archivo<<"\n";
    /*
      for(int j=0;j<retBits();j++)
      archivo<<ind[i].genotipo[j];
      archivo<<"\n";
    */
  }
}
/*
The parameters to call the micro-GA are:


.
2.
3.
4.
5.
6.
7.

 */
int main(int argc, char **argv)
{
  char archivo[20];
  int tamPARETO=100;
  int tamMem=50;
  int cualfuncion=22;
  int GMax=1250;
  int M=4;
  int nTope=1;
  int nGenes=28;
  int nObjs=2;
  int base=2;
  int subDivs=2;
  double Pc=0.5,Pm=0.028;
  double *linf=new(double[28]);
  double *lsup=new(double[28]);
  int *pres=new(int[2]);
  //  double linf=0,lsup=1;
  //int pres=0;
  linf[0]=0;
  lsup[0]=1;
  pres[0]=0;
  int sndelit=50;
  double pNRem=0.3;
  //nbits 28
  if(argc!=2){
    cout<<"Use: "<<argv[0]<<" output_file\n";
    exit(1);
  }
  strcpy(archivo,argv[1]);
  
  Barbosa mag(GMax,nTope,M,Pc,Pm,nGenes,nObjs,tamPARETO,tamMem,subDivs,base,linf,lsup,pres,1,sndelit,pNRem,archivo);
  mag.Alg();
}
