#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "magm.h"

/*
Funcion de Kita

Maximize
f1(x,y) = -x**2 + y
f2(x,y) = x/2 + y + 1
  
constraints
0 <= x <= 10
0 <= y <= 10
****
  0 >= x/6 + y - 13/2
  0 >= x/2 + y - 15/2
  0 >= 5x + y - 30

*/

class Kita:public MicroAG{
public:  
  Kita(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double *lsup,int *pres,int iguales,int sndelit,  double pNRem,char *arch):  MicroAG(itot,gmax,m,pc,pm,ngenes,nobjs,tampareto,tammem,ndivs,b,linf,lsup,pres,iguales,sndelit,pNRem,arch){};
public:
  void evalua(int *cromosoma,double *aptitud);
  void salida(Individuo *ind);
  int restricciones(int *genotipo);
};

void Kita::evalua(int *cromosoma,double *aptitud){
  double x=decodifica(0,cromosoma);
  double y=decodifica(1,cromosoma);
  aptitud[0]=(-x*x+y)*-1;
  aptitud[1]=(x/2.0 + y + 1)*-1;
}

void Kita::salida(Individuo *ind){
  for(int i=0;i<posPARETO;i++){
    //cout<<ind[i].loc<<" ";
    //imprime2(ind[i].aptObj,nObjs);
    //cout<<"\t";
    //almacena(ind[i].aptObj,nObjs);
    for(int j=0;j<nObjs;j++)
      archivo<<ind[i].aptObj[j]*-1<<"\t";
    archivo<<"\n";
    
    /*
      double fenotipo=0.0,x,y;
      int j;
      int *cadena,*pb;
      cadena=gray_A_binario(ind[i].genotipo);
      pb=cadena;
      for(j=0;j<15;j++)//recorrer todo el genotipo, para hacer la suma
      fenotipo+=ldexp(pb[j],j);//de las potencias de dos reespectivas y
      x=1+fenotipo*4/(pow(base,15)-1); 

      fenotipo=0.0;
      for(j=0;j<14;j++)//recorrer todo el genotipo, para hacer la suma
      fenotipo+=ldexp(pb[j+14],j);//de las potencias de dos reespectivas y
      delete cadena;
      y=1+fenotipo*2/(pow(base,14)-1);

      archivo<<x;
      archivo<<"\t";
      archivo<<y;
      archivo<<"\n";
    */
  }
}
int Kita::restricciones(int *genotipo){
  //  cout<<"cotz\n";
  int violadas=0;
  double x=decodifica(0,genotipo);
  double y=decodifica(1,genotipo);

  if( 0 < (double)(x/6.0 + y - 13.0/2.0 )) violadas ++;
  if( 0 < (double)(x/2.0 + y - 15.0/2.0) ) violadas ++;
  if( 0 < (double)(5*x + y - 30) ) violadas ++;
  return violadas;
}
int main(int argc, char **argv)
{
  //instanciacion de un objeto GeneticoSimple(Pc,Pm,M,GMax,rmin,rmax,dec,arch);
  //donde Pc=porcentaje de cruza (0.0 a 1.0)
  //donde Pm=porcentaje de mutacion (0.0 a 1.0)
  //donde GMax=numero maximo de generaciones
  //nombre del archivo.
  char archivo[20];
  int tamPARETO=100;
  int tamMem=50;
  int GMax=2500;
  int M=4;
  int nTope=2;
  int nGenes=2;
  int nObjs=2;
  int base=2;
  int subDivs=25;
  double Pc=0.7;
  double Pm=(double) 1.0/46.0;
  double *linf=new(double[2]);//=0.1;
  double *lsup=new(double[2]);//=1;
  int *pres=new(int[2]);//=4;
  linf[0]=0.0;
  linf[1]=0.0;
  lsup[0]=7.0;
  lsup[1]=7.0;
  pres[0]=6;
  pres[1]=6;
  int sndelit=200;
  double pNRem=0.2;
  if(argc!=2){
    cout<<"Use: "<<argv[0]<<" output_file\n";
    exit(1);
  }
  strcpy(archivo,argv[1]);


  Kita  mag(GMax,nTope,M,Pc,Pm,nGenes,nObjs,tamPARETO,tamMem,subDivs,base,linf,lsup,pres,1,sndelit,pNRem,archivo);
  mag.Alg();//inicia el algoritmo. 
}

