#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "magm.h"
/*
Funcion de Osyczka

Minimize
f1(x,y)=x+y**2
f2(x,y)=x/2+y+1

constraints
2 <= x <= 7
5 <= y <= 10

****

0 >= 12 - x -y
0 >= x**2 + 10x - y**2 +16y -80
*/

class Osyczka:public MicroAG{
public:  
  Osyczka(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double *lsup,int *pres,int iguales,int sndelit,  double pNRem,char *arch):  MicroAG(itot,gmax,m,pc,pm,ngenes,nobjs,tampareto,tammem,ndivs,b,linf,lsup,pres,iguales,sndelit,pNRem,arch){};
public:
  void evalua(int *cromosoma,double *aptitud);
  void salida(Individuo *ind);
  int restricciones(int *genotipo);
};
void Osyczka::evalua(int *cromosoma,double *aptitud){
  double x=decodifica(0,cromosoma);
  double y=decodifica(1,cromosoma);
  aptitud[0]=x+y*y;
  aptitud[1]=x*x+y;
}
void Osyczka::salida(Individuo *ind){
  for(int i=0;i<posPARETO;i++){
    //cout<<ind[i].loc<<" ";
    //imprime2(ind[i].aptObj,nObjs);
    //cout<<"\t";
    
    almacena(ind[i].aptObj,nObjs);
    archivo<<"\n";
    
    /*
      double fenotipo=0.0,x,y;
      int j;
      int *cadena,*pb;
      cadena=gray_A_binario(ind[i].genotipo);
      pb=cadena;
      for(j=0;j<15;j++)//recorrer todo el genotipo, para hacer la suma
      fenotipo+=ldexp(pb[j],j);//de las potencias de dos reespectivas y
      x=1+fenotipo*4/(pow(base,15)-1); 

      fenotipo=0.0;
      for(j=0;j<14;j++)//recorrer todo el genotipo, para hacer la suma
      fenotipo+=ldexp(pb[j+14],j);//de las potencias de dos reespectivas y
      delete cadena;
      y=1+fenotipo*2/(pow(base,14)-1);

      archivo<<x;
      archivo<<"\t";
      archivo<<y;
      archivo<<"\n";
    */
  }
}
int Osyczka::restricciones(int *genotipo){
  //  cout<<"cotz\n";
  int violadas=0;
  double x=decodifica(0,genotipo);
  double y=decodifica(1,genotipo);
  if( 0 > 12 -x -y ) violadas++;
  if( 0 > x*x + 10*x - y*y + 16*y - 80 ) violadas++;
  return violadas;
}
int main(int argc, char **argv)
{
  //instanciacion de un objeto GeneticoSimple(Pc,Pm,M,GMax,rmin,rmax,dec,arch);
  //donde Pc=porcentaje de cruza (0.0 a 1.0)
  //donde Pm=porcentaje de mutacion (0.0 a 1.0)
  //donde GMax=numero maximo de generaciones
  //nombre del archivo.
  char archivo[20];
  int tamPARETO=100;
  int tamMem=50;
  int GMax=5000;
  int M=4;
  int nTope=2;
  int nGenes=2;
  int nObjs=2;
  int base=2;
  int subDivs=25;
  double Pc=0.7;
  double Pm=(double) 1.0/60.0;
  double *linf=new(double[2]);
  double *lsup=new(double[2]);
  int *pres=new(int[2]);
  linf[0]=1.0;
  linf[1]=4.0;
  lsup[0]=7.0;
  lsup[1]=10.0;
  pres[0]=8;
  pres[1]=8;
  int sndelit=100;
  double pNRem=0.3;
  if(argc!=2){
    cout<<"Use: "<<argv[0]<<" output_file\n";
    exit(1);
  }
  strcpy(archivo,argv[1]);


   Osyczka mag(GMax,nTope,M,Pc,Pm,nGenes,nObjs,tamPARETO,tamMem,subDivs,base,linf,lsup,pres,0,sndelit,pNRem,archivo);
  mag.Alg();//inicia el algoritmo. 
}
