#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <malloc.h>
#include "magm.h"
/*
A four bar plane truss

Minimize
f1(x,y)= L*(2*x1+sqrt(2*x2)+sqrt(x3)+x4)
f2(x,y)= F*L/E*(2/x2 + (2*sqrt(2))/x2 - (2*sqrt(2))/x3 + 2/x4

such that
(F/r) <= x1 <= 3*(F/r)
sqrt(2)*(F/r) <= x2 <= 3*(F/r)
sqrt(2)*(F/r) <= x3 <= 3*(F/r)
(F/r) <= x4 <= 3*(F/r)

where
F = 10kN
E = 2*10^5 kN/cm^2
L = 200 cm
r = 10kN/cm^3
*/

class truss:public MicroAG{
public:  
  truss(int itot, int gmax,int m,double pc,double pm,int ngenes,int nobjs, int tampareto,int tammem, int ndivs,int b,double *linf,double* lsup,int *pres,int iguales,int sndelit,  double pNRem,char *arch):  MicroAG(itot,gmax,m,pc,pm,ngenes,nobjs,tampareto,tammem,ndivs,b,linf,lsup,pres,iguales,sndelit,pNRem,arch){};
public:
  void evalua(int *cromosoma,double *aptitud);
  void salida(Individuo *ind);
};
void truss::evalua(int *cromosoma,double *aptitud){
  double x1=decodifica(0,cromosoma);
  double x2=decodifica(1,cromosoma);
  double x3=decodifica(2,cromosoma);
  double x4=decodifica(3,cromosoma);
  double F = 10;
  double E = 2*pow(10,5);
  double L = 200;

  aptitud[0]= L*(2*x1+sqrt(2*x2)+sqrt(x3)+x4);
  aptitud[1]= (F*L)/E * ( 2/x2 + (2*sqrt(2))/x2 - (2*sqrt(2))/x3 + 2/x4 );
}
void truss::salida(Individuo *ind){
  for(int i=0;i<posPARETO;i++){
    almacena(ind[i].aptObj,nObjs);
    archivo<<"\n";
  }
}
int main(int argc, char **argv)
{
  //instanciacion de un objeto GeneticoSimple(Pc,Pm,M,GMax,rmin,rmax,dec,arch);
  //donde Pc=porcentaje de cruza (0.0 a 1.0)
  //donde Pm=porcentaje de mutacion (0.0 a 1.0)
  //donde GMax=numero maximo de generaciones
  //nombre del archivo.
  char archivo[20];
  int tamPARETO=100;
  int tamMem=50;
  int GMax=10000;
  int M=4;
  int nTope=4;
  int nGenes=4;
  int nObjs=2;
  int base=2;
  int subDivs=25;
  double Pc=0.7;
  double Pm=(double) 1.0/58.0;
  double *linf=new(double[4]);//=0.1;
  double *lsup=new(double[4]);//=1;
  int *pres=new(int[4]);//=4;

  double F = 10.0;
  double E = 2*pow(10,5);
  double L = 200.0;
  double r = 10.0;
  
  linf[0]=(F/r);//0.05
  lsup[0]=3*(F/r);//0.15
  linf[1]=sqrt(2)*(F/r);//0.070710678
  lsup[1]=3*(F/r);//0.15
  linf[2]=sqrt(2)*(F/r);//0.070710678
  lsup[2]=3*(F/r);//0.15
  linf[3]=(F/r);//0.05
  lsup[3]=3*(F/r);//0.015

  pres[0]=4;
  pres[1]=4;
  pres[2]=4;
  pres[3]=4;
   int sndelit=100;
  double pNRem=0.3;
  if(argc!=2){
    cout<<"Use: "<<argv[0]<<"output_file\n";
    exit(1);
  }
  strcpy(archivo,argv[1]);

   truss mag(GMax,nTope,M,Pc,Pm,nGenes,nObjs,tamPARETO,tamMem,subDivs,base,linf,lsup,pres,0,sndelit,pNRem,archivo);
  mag.Alg();//inicia el algoritmo. 
}
